Option Explicit

'***************************************************************
'enableDHCP.vbs
'DHCPLɂ

'(C) 2018 Koichi Asawa
'***************************************************************

Dim fso
Dim inputFile
Dim outputFile
Dim networkAdapterIndex
Dim hostName
Dim locater
Dim service
Dim items
Dim i
Dim item
Dim dns
Dim ret
Dim enableDHCP

Set fso = WScript.CreateObject("Scripting.FileSystemObject")

If Not fso.FileExists("data\executeFlag.dat") Then
    Set fso = Nothing
    WScript.Quit
End If

Set inputFile = fso.OpenTextFile("data\executeFlag.dat", 1)

If inputFile.ReadLine = "true" Then
    inputFile.Close
    Set outputFile = fso.OpenTextFile("data\executeFlag.dat", 2, True)
    outputFile.WriteLine "false"
    outputFile.Close
Else
    inputFile.Close
    Set fso = Nothing
    Set inputFile = Nothing
    WScript.Quit
End If

Set inputFile = fso.OpenTextFile("data\selectedNetworkAdapterIndex.dat", 1)
networkAdapterIndex = int(inputFile.ReadLine)
inputFile.Close
hostName="."  '@w肷
Set locater = CreateObject("WbemScripting.SWbemLocator")
Set service = locater.ConnectServer(hostName, "root/cimv2")
Set items = service.ExecQuery("Select * From Win32_NetworkAdapterConfiguration Where IPEnabled = True", , 48)

i = 1  'CfbNX̍ŏlݒ肷
dns = Array()

For Each item In items
    'Ylbg[NA_v^ȂΏs
    If networkAdapterIndex = i Then
        ret = item.EnableDHCP()

        If ret = 0 Then
            ret = item.SetDNSServerSearchOrder(dns)

            If ret = 0 Then
                enableDHCP = ""
            Else
                enableDHCP = "s"
            End If
        Else
            enableDHCP = "s"
        End If
    End If

    i = i + 1
Next

Set outputFile = fso.OpenTextFile("data\enableDHCP.dat", 2, True)
outputFile.WriteLine enableDHCP
outputFile.Close

Set fso = Nothing
Set inputFile = Nothing
Set outputFile = Nothing
Set locater = Nothing
Set service = Nothing
Set items = Nothing
Set item = Nothing
