Option Explicit

'***************************************************************
'enableStatic.vbs
'ÓIIPAhXݒ肷

'(C) 2018 Koichi Asawa
'***************************************************************

Dim fso
Dim inputFile
Dim outputFile
Dim networkAdapterIndex
Dim staticIPAddress
Dim subnetMask
Dim gateway
Dim primaryDNS
Dim secondaryDNS
Dim staticIPAddressArray
Dim subnetMaskArray
Dim gatewayArray
Dim dnsArray
Dim hostName
Dim locater
Dim service
Dim items
Dim i
Dim item
Dim ret
Dim enableStatic

Set fso = WScript.CreateObject("Scripting.FileSystemObject")

If Not fso.FileExists("data\executeFlag.dat") Then
    Set fso = Nothing
    WScript.Quit
End If

Set inputFile = fso.OpenTextFile("data\executeFlag.dat", 1)

If inputFile.ReadLine = "true" Then
    inputFile.Close
    Set outputFile = fso.OpenTextFile("data\executeFlag.dat", 2, True)
    outputFile.WriteLine "false"
    outputFile.Close
Else
    inputFile.Close
    Set fso = Nothing
    Set inputFile = Nothing
    WScript.Quit
End If

Set inputFile = fso.OpenTextFile("data\selectedNetworkAdapterIndex.dat", 1)
networkAdapterIndex = int(inputFile.ReadLine)
inputFile.Close
Set inputFile = fso.OpenTextFile("data\staticIPAddress.dat", 1)
staticIPAddress = inputFile.ReadLine
inputFile.Close
Set inputFile = fso.OpenTextFile("data\subnetMask.dat", 1)
subnetMask = inputFile.ReadLine
inputFile.Close
Set inputFile = fso.OpenTextFile("data\gateway.dat", 1)
gateway = inputFile.ReadLine
inputFile.Close
Set inputFile = fso.OpenTextFile("data\primaryDNS.dat", 1)
primaryDNS = inputFile.ReadLine
inputFile.Close
Set inputFile = fso.OpenTextFile("data\secondaryDNS.dat", 1)
secondaryDNS = inputFile.ReadLine
inputFile.Close
staticIPAddressArray = Array(staticIPAddress)
subnetMaskArray = Array(subnetMask)
gatewayArray = Array(gateway)

If Len(secondaryDNS) = 0 Then
    dnsArray = Array(primaryDNS)
Else
    dnsArray = Array(primaryDNS, secondaryDNS)
End If

hostName="."  '@w肷
Set locater = CreateObject("WbemScripting.SWbemLocator")
Set service = locater.ConnectServer(hostName, "root/cimv2")
Set items = service.ExecQuery("Select * From Win32_NetworkAdapterConfiguration Where IPEnabled = True", , 48)
i = 1  'CfbNX̍ŏlݒ肷

For Each item In items
    'Ylbg[NA_v^ȂΏs
    If networkAdapterIndex = i Then
        ret = item.EnableStatic(staticIPAddressArray, subnetMaskArray)

        If ret = 0 Then
            ret = item.SetGateways(gatewayArray)

            If ret = 0 Then
                ret = item.SetDnsServerSearchOrder(dnsArray)

                If ret = 0 Then
                    enableStatic = ""
                    Exit For
                Else
                    enableStatic = "s"
                    Exit For
                End If
            Else
                enableStatic = "s"
                Exit For
            End If
        Else
            enableStatic = "s"
            Exit For
        End If
    End If

    i = i + 1
Next

Set outputFile = fso.OpenTextFile("data\enableStatic.dat", 2, True)
outputFile.WriteLine enableStatic
outputFile.Close

Set fso = Nothing
Set inputFile = Nothing
Set outputFile = Nothing
Set locater = Nothing
Set service = Nothing
Set items = Nothing
Set item = Nothing
