Option Explicit

'***************************************************************
'networkAdapterConfiguration.vbs
'Ylbg[NA_v^̃vpeBt@C֏o͂

'(C) 2018 Koichi Asawa
'***************************************************************

Dim fso
Dim inputFile
Dim outputFile
Dim networkAdapterIndex
Dim hostName
Dim locater
Dim service
Dim items
Dim networkAdapterConfiguration
Dim i
Dim exitFlag
Dim item
Dim j
Dim octets
Dim ipAddress
Dim subnetMask
Dim gateway
Dim primaryDNS
Dim secondaryDNS
Dim dhcpEnabled
Dim line

Set fso = WScript.CreateObject("Scripting.FileSystemObject")

If Not fso.FileExists("data\executeFlag.dat") Then
    Set fso = Nothing
    WScript.Quit
End If

Set inputFile = fso.OpenTextFile("data\executeFlag.dat", 1)

If inputFile.ReadLine = "true" Then
    inputFile.Close
    Set outputFile = fso.OpenTextFile("data\executeFlag.dat", 2, True)
    outputFile.WriteLine "false"
    outputFile.Close
Else
    inputFile.Close
    Set fso = Nothing
    Set inputFile = Nothing
    WScript.Quit
End If

Set inputFile = fso.OpenTextFile("data\selectedNetworkAdapterIndex.dat", 1)
networkAdapterIndex = int(inputFile.ReadLine)
inputFile.Close
hostName="."  '@w肷
Set locater = CreateObject("WbemScripting.SWbemLocator")
Set service = locater.ConnectServer(hostName, "root/cimv2")
Set items = service.ExecQuery("Select * From Win32_NetworkAdapterConfiguration Where IPEnabled = True", , 48)
Set networkAdapterConfiguration = CreateObject("System.Collections.ArrayList")  'ϐ𓮓Izɂ
i = 1  'CfbNX̍ŏlݒ肷
exitFlag = False

For Each item In items
    'Ylbg[NA_v^ȂΏs
    If networkAdapterIndex = i Then
        For j = LBound(item.IPAddress) To UBound(item.IPAddress)
            octets = Split(item.IPAddress(j), ".")

            'IPAhXIPv4ȂΏs
            If (UBound(octets) + 1) = 4 Then
                networkAdapterConfiguration.add "A_v^F" & item.Description(j)
                networkAdapterConfiguration.add "MACAhXF" & item.MACAddress(j)
                ipAddress = item.IPAddress(j)
                networkAdapterConfiguration.add "IPAhXF" & item.IPAddress(j)
                subnetMask = item.IPSubnet(j)
                networkAdapterConfiguration.add "Tulbg}XNF" & item.IPSubnet(j)

                If IsArray(item.DefaultIPGateway) Then
                    gateway = item.DefaultIPGateway(j)
                    networkAdapterConfiguration.add "Q[gEFCT[oF" & item.DefaultIPGateway(j)
                Else
                    gateway =  ""
                    networkAdapterConfiguration.add "Q[gEFCT[oF"
                End If

                If IsArray(item.DNSServerSearchOrder) Then
                    If UBound(item.DNSServerSearchOrder) = 0 Then
                        primaryDNS = item.DNSServerSearchOrder(j)
                        networkAdapterConfiguration.add "DDNST[oF" & item.DNSServerSearchOrder(j)
                        secondaryDNS = ""
                        networkAdapterConfiguration.add "DNST[oF"
                    Else
                        primaryDNS = item.DNSServerSearchOrder(j)
                        networkAdapterConfiguration.add "DDNST[oF" & item.DNSServerSearchOrder(j)
                        secondaryDNS = item.DNSServerSearchOrder(j + 1)
                        networkAdapterConfiguration.add "DNST[oF" & item.DNSServerSearchOrder(j + 1)
                    End If
                Else
                    primaryDNS = ""
                    networkAdapterConfiguration.add "DDNST[oF"
                    secondaryDNS = ""
                    networkAdapterConfiguration.add "DNST[oF"
                End If

                networkAdapterConfiguration.add "DHCPT[oF" & item.DHCPServer(j)

                If item.DHCPEnabled(j) = True Then
                    dhcpEnabled = "L"
                    networkAdapterConfiguration.add "DHCP̏ԁFL"
                Else
                    dhcpEnabled = ""
                    networkAdapterConfiguration.add "DHCP̏ԁF"
                End If

                exitFlag = True
                Exit For
            End If
        Next

        If exitFlag Then
            Exit For
        End If
    End If

    i = i + 1
Next

Set outputFile = fso.OpenTextFile("data\ipAddress.dat", 2, True)
outputFile.WriteLine ipAddress
outputFile.Close
Set outputFile = fso.OpenTextFile("data\subnetMask.dat", 2, True)
outputFile.WriteLine subnetMask
outputFile.Close
Set outputFile = fso.OpenTextFile("data\gateway.dat", 2, True)
outputFile.WriteLine gateway
outputFile.Close
Set outputFile = fso.OpenTextFile("data\primaryDNS.dat", 2, True)
outputFile.WriteLine primaryDNS
outputFile.Close
Set outputFile = fso.OpenTextFile("data\secondaryDNS.dat", 2, True)
outputFile.WriteLine secondaryDNS
outputFile.Close
Set outputFile = fso.OpenTextFile("data\dhcpEnabled.dat", 2, True)
outputFile.WriteLine dhcpEnabled
outputFile.Close
Set outputFile = fso.OpenTextFile("data\networkAdapterConfiguration.dat", 2, True)

For Each line in networkAdapterConfiguration
    outputFile.WriteLine line
Next

outputFile.Close

Set fso = Nothing
Set inputFile = Nothing
Set outputFile = Nothing
Set locater = Nothing
Set service = Nothing
Set items = Nothing
Set networkAdapterConfiguration = Nothing
Set item = Nothing
